' InvokeVerbEx.VBS V1.01 (C) yoshioka.teruo@nifty.com 2006-10-08
' InvokeVerbEx.VBS calls FolderItem.InvokeVerb() from command line.
' Usage: Start InvokeVerbEx.VBS [/v:Verb] File [Args...]

Option Explicit
Dim k
Dim Verbose
Dim VerbName
Dim Path
Dim Arg
Dim Args
Dim Shell
Dim n
Dim ie
Dim fso
Dim ParentFolder
Dim FileName
Dim ExtensionName
Dim wShell
Dim ClassName
Dim VerbText
Dim Folder
Dim FolderItem
Dim Verb
Dim Verbs

For k=0 To WScript.Arguments.Count-1
  Select Case LCase(Left(WScript.Arguments.Item(k),3))
  Case "/v:"
    VerbName=Mid(WScript.Arguments.Item(k),4)
  Case "/d"
    Verbose=True
  Case Else
    Exit For
  End Select
Next
If k=WScript.Arguments.Count Then
  WScript.Echo "Usage: Start InvokeVerbEx.VBS [/v:Verb] File [Args...]"
  WScript.Quit
End If
Path=WScript.Arguments.Item(k)
Args=Array()
For k=k+1 To WScript.Arguments.Count-1
  Arg=WScript.Arguments.Item(k)
  If InStr(Arg," ") Then
    Push Args,""""&Arg&""""
  Else
    Push Args,Arg
  End If
Next
Args=Join(Args)

Set Shell=CreateObject("Shell.Application") 
For n=0 To 99 
  For Each ie In Shell.Windows() 
    If ie.ReadyState<>4 Then
    ElseIf ie.Busy Then
    ElseIf n>0 And ie.Visible Then
    ElseIf InStr(TypeName(ie.Document),"IShellFolderViewDual") Then
      Exit For 
    End If
  Next 
  If Not IsEmpty(ie) Then Exit For 
  If n=0 Then CreateObject("WScript.Shell").Run "Explorer.EXE",0,True 
  WScript.Sleep 100 
Next 
If IsEmpty(ie) Then
  WScript.Echo "Failed"
  WScript.Quit 
End If
Set Shell=ie.Document.Application 
If InStr(TypeName(Shell),"IShellDispatch")=0 Then
  WScript.Echo TypeName(Shell)
  WScript.Quit
End If

Set fso=CreateObject("Scripting.FileSystemObject")
If InStr(Path,":")=0 Then Path=fso.GetAbsolutePathName(Path)
ParentFolder=fso.GetParentFolderName(Path)
FileName=fso.GetFileName(Path)
ExtensionName=fso.GetExtensionName(Path)

Set wShell=CreateObject("WScript.Shell")
Set Folder=Shell.NameSpace(ParentFolder)
If Folder Is Nothing Then
  WScript.Echo ParentFolder,"Not Found."
Else
  Set FolderItem=Folder.ParseName(FileName)
  If FolderItem Is Nothing Then
    WScript.Echo FileName,"Not Found."
  Else
    ClassName=RegRead("HKCR\."&ExtensionName&"\")
    If VerbName="" Then
      ReDim Verbs(FolderItem.Verbs.Count-1)
      For k=0 To FolderItem.Verbs.Count-1
        Verbs(k)=Join(Array(k,FolderItem.Verbs.Item(k).Name))
      Next
      Do
        k=InputBox(Join(Verbs,vbLf),"Select Menu Item by Number...","0")
        If k="" Then
          Exit Do
        ElseIf IsNumeric(k) Then
          k=CLng(k)
          If 0=<k And k<FolderItem.Verbs.Count Then
            VerbName=FolderItem.Verbs.Item(k).Name
            If VerbName<>"" Then
              FolderItem.InvokeVerbEx (VerbName),(Args)
              Exit Do
            End If
          End If
        End If
      Loop
    Else
      If Not IsEmpty(RegRead("HKCR\."&ExtensionName&"\Shell\"&VerbName&"\Command\")) Then
        VerbText=RegRead("HKCR\."&ExtensionName&"\Shell\"&VerbName&"\")
        If Verbose Then WScript.Echo ExtensionName,VerbText
      ElseIf Not IsEmpty(RegRead("HKCR\"&ClassName&"\Shell\"&VerbName&"\Command\")) Then
        VerbText=RegRead("HKCR\"&ClassName&"\Shell\"&VerbName&"\")
        If Verbose Then WScript.Echo ClassName,VerbText
      End If
      For Each Verb In FolderItem.Verbs
        If LCase(Verb.Name)=LCase(VerbName) Then Exit For
        If Not IsEmpty(VerbText) Then If Verb.Name=VerbText Then Exit For
      Next
      If IsEmpty(Verb) Then
        If Verbose Then WScript.Echo VerbName,"Not Found."
        FolderItem.InvokeVerbEx (VerbName),(Args)
      Else
        If Verbose Then WScript.Echo Verb.Name
        FolderItem.InvokeVerbEx (Verb.Name),(Args)
        Set Verb=Nothing
      End If
    End If
    Set FolderItem=Nothing
  End If
  Set Folder=Nothing
End If

If n Then If ie.Visible=False Then ie.Quit

Function RegRead(key)
On Error Resume Next
RegRead=wShell.RegRead(key)
End Function

Sub Push(Items,Item)
ReDim Preserve Items(UBound(Items)+1)
Items(UBound(Items))=Item
End Sub
